function [w1 w2 tp k like] = dndsml_phase1_ss(piA,piB,hexa_piA,hexa_piB,nijA,nijB)

global indQ1 indQ2 avg_mat1 avg_mat2 sites1 sites2 hexas_pi1 hexas_pi2 codon_pi1 codon_pi2;

load('ss_phase1_likelihood_variables','indQ1','indQ2','avg_mat1','avg_mat2','hexas1','hexas2')

%if (isempty(n_sites))
    %sites1 = get_sites(seq1(1:end-3), seq2(1:end-3));
    %sites2 = get_sites(seq1(2:end-2), seq2(2:end-2));
%else
sites1 = load(nijA,'-ascii');
sites2 = load(nijB,'-ascii');
%end

%hexas_pi1 = hexa1_f3x4(a1, a2, hexas1);
%hexas_pi2 = hexa2_f3x4(b1, b2, hexas2);
hexas_pi1 = load(hexa_piA,'-ascii');
hexas_pi2 = load(hexa_piB,'-ascii');
hexas_pi1 = repmat(hexas_pi1,length(hexas_pi1),1);
hexas_pi2 = repmat(hexas_pi2,length(hexas_pi2),1);

%if (isempty(pi))
    %codon_pi1 = f3x4(a1, a2);
    %codon_pi2 = f3x4(b1, b2);
%else
codon_pi1 = load(piA,'-ascii');
codon_pi2 = load(piB,'ascii');
%   end

codon_pi1 = repmat(codon_pi1,length(codon_pi1),1);
codon_pi2 = repmat(codon_pi2,length(codon_pi2),1);

options = optimset('LargeScale','off','Display','off','Algorithm','active-set');
params = fmincon(@(x)get_likelihood_ov(x(1),x(2),x(3),x(4)),...
    [1 1 1 1],[],[],[],[],[0.001 0.001 0.001 0.001],[50 50 50 5],[],options);

k = params(1);
w1 = params(2);
w2 = params(3);
tp = params(4);

like = get_likelihood_ov(k,w1,w2,tp);


% function sites = get_sites(seq1, seq2)
% % returns a matrix with site counts for each codon pair
% % skips gaps
% if length(seq1)~= length(seq2)
%     'Warning: unequal sequence lengths'
% end
% sites = zeros(64,64);
% int_c1 = intnt2intc(seq1);
% int_c2 = intnt2intc(seq2);
% len = min(length(int_c1),length(int_c2));
% for i=1:len
%     sites(int_c1(i),int_c2(i)) = sites(int_c1(i),int_c2(i)) + 1;
% end

% remove stop codons entries
% stop_codons = intnt2intc([4 1 1 4 1 3 4 3 1]);
% sites(stop_codons,:) = [];
% sites(:,stop_codons) = [];


% function f = get_codon_frequencies(seq)
% 
% f = zeros(1,64);
% c = intnt2intc(seq);
% 
% for i=1:64
%     f(i) = length(find(c==i));
% end
% 
% function freq = freq3x4(seq)
% % calculate the F3x4 model frequencies
% 
% codons = reshape(seq,3,length(seq)/3);
% freq = zeros(3,4);
% for i=1:3
%     for j=1:4
%         freq(i,j) = sum(codons(i,:)==j)/length(codons(i,:));
%     end
% end
% 
% 
% function f = f3x4(seq1,seq2)
% % calculate the average frequenct of codons in the two sequences according to F3x4 model
% f = zeros(1,64);
% 
% freq1 = freq3x4(seq1);
% freq2 = freq3x4(seq2);
% 
% for i=1:64
%     cod = intc2intnt(i);
%     f(i) = mean([freq1(1,cod(1))*freq1(2,cod(2))*freq1(3,cod(3)),...
%                 freq2(1,cod(1))*freq2(2,cod(2))*freq2(3,cod(3))]);
% end
% 
% stop_codons = intnt2intc([4 1 1 4 1 3 4 3 1]);
% f(stop_codons) = [];
% 
% 
% 
% function f = hexa1_f3x4(seq1,seq2,hexas)
% % calculate the frequency of phase 1 hexas according to F3x4 model
% % codons of gene 1 are in positions 3-5 in the hexa
% f = zeros(1,length(hexas));
% 
% freq1 = freq3x4(seq1);
% freq2 = freq3x4(seq2);
% 
% for i=1:length(f)
%     h = hexas(i,:);
%     f(i) = mean([freq1(2,h(1))*freq1(3,h(2))*freq1(1,h(3))*freq1(2,h(4))*freq1(3,h(5))*freq1(1,h(6)),...
%                 freq2(2,h(1))*freq2(3,h(2))*freq2(1,h(3))*freq2(2,h(4))*freq2(3,h(5))*freq2(1,h(6))]);
% end
% 
% function f = hexa2_f3x4(seq1,seq2,hexas)
% % calculate the frequency of phase 2 hexas according to F3x4 model
% % codons of gene 1 are in positions 2-4 in the hexa
% f = zeros(1,length(hexas));
% 
% freq1 = freq3x4(seq1);
% freq2 = freq3x4(seq2);
% 
% for i=1:length(f)
%     h = hexas(i,:);
%     f(i) = mean([freq1(3,h(1))*freq1(1,h(2))*freq1(2,h(3))*freq1(3,h(4))*freq1(1,h(5))*freq1(2,h(6)),...
%                 freq2(3,h(1))*freq2(1,h(2))*freq2(2,h(3))*freq2(3,h(4))*freq2(1,h(5))*freq2(2,h(6))]);
% end


function like = get_likelihood_ov(kappa,omega1,omega2,t)

global indQ1 indQ2 avg_mat1 avg_mat2 sites1 sites2 hexas_pi1 hexas_pi2 codon_pi1 codon_pi2;

Q1 = indQ1;
Q2 = indQ2;

sstv = (Q1 == 1);
ssts = (Q1 == 2);
nstv = (Q1 == 3);
nsts = (Q1 == 4);
sntv = (Q1 == 5);
snts = (Q1 == 6);
nntv = (Q1 == 7);
nnts = (Q1 == 8);

Q1(sstv) = hexas_pi1(sstv);
Q1(ssts) = kappa*hexas_pi1(ssts);
Q1(nstv) = omega1*hexas_pi1(nstv);
Q1(nsts) = omega1*kappa*hexas_pi1(nsts);
Q1(sntv) = omega2*hexas_pi1(sntv);
Q1(snts) = omega2*kappa*hexas_pi1(snts);
Q1(nntv) = omega1*omega2*hexas_pi1(nntv);
Q1(nnts) = omega1*omega2*kappa*hexas_pi1(nnts);

Q_avg1 = (avg_mat1*Q1)*avg_mat1';

Q_avg1 = Q_avg1 + diag(-sum(Q_avg1,2));
Q_avg1 = Q_avg1 ./ -sum(diag(codon_pi1).*diag(Q_avg1));

P1 = expm(Q_avg1 * t);

% omega are switching on the different frames
temp = omega1;
omega1 = omega2;
omega2 = temp;

sstv = (Q2 == 1);
ssts = (Q2 == 2);
nstv = (Q2 == 3);
nsts = (Q2 == 4);
sntv = (Q2 == 5);
snts = (Q2 == 6);
nntv = (Q2 == 7);
nnts = (Q2 == 8);

Q2(sstv) = hexas_pi2(sstv);
Q2(ssts) = kappa*hexas_pi2(ssts);
Q2(nstv) = omega1*hexas_pi2(nstv);
Q2(nsts) = omega1*kappa*hexas_pi2(nsts);
Q2(sntv) = omega2*hexas_pi2(sntv);
Q2(snts) = omega2*kappa*hexas_pi2(snts);
Q2(nntv) = omega1*omega2*hexas_pi2(nntv);
Q2(nnts) = omega1*omega2*kappa*hexas_pi2(nnts);

Q_avg2 = (avg_mat2*Q2)*avg_mat2';

Q_avg2 = Q_avg2 + diag(-sum(Q_avg2,2));
Q_avg2 = Q_avg2 ./ -sum(diag(codon_pi2).*diag(Q_avg2));

P2 = expm(Q_avg2 * t);

like = -sum(sum(sites1 .* log(P1.*codon_pi1))) - sum(sum(sites2 .* log(P2.*codon_pi2)));

