function ntintseq = randCodonDNAseq(length,w)
% return a random codon based DNA sequence 
% length - number of codons
% w - wieghts of the codons - if you want without stop codons w should have
% zero at positions 4, 12 and 36
global gcode;

if isempty(gcode)
    build_gcode();
end

codons = randsample([1:64],length,true,w);

codon_mat = gcode.c2ntint(codons,:);

ntintseq = reshape(codon_mat',1,length*3);
