function ntintseq = randCodonDNAseq_no_stops(len,phase)
% return a random codon based DNA sequence with no stop codons in phase 0 
% and the given phase 
% len - number of codons
% phase - the overlap phase to consider
global gcode;

if isempty(gcode)
    build_gcode();
end

stop_codons = intnt2intc([4 1 1 4 1 3 4 3 1]);
codon_w = ones(1,64);
codon_w(stop_codons) = 0;

c_seq = randsample(64,len*5,true,codon_w);

nt_seq = intc2intnt(c_seq);
org_codons = reshape(nt_seq,3,length(nt_seq)/3);
phase_seq = nt_seq(1+phase:end-3+phase);
codons=reshape(phase_seq,3,length(phase_seq)/3);

stops = find(all(codons == repmat(mynt2int('TGA')',1,length(codons)))|...
             all(codons == repmat(mynt2int('TAG')',1,length(codons)))|...
             all(codons == repmat(mynt2int('TAA')',1,length(codons))));

while length(stops) > 0
   
    rm_index = [stops, stops+1];
    org_codons(:,rm_index) = [];
    nt_seq = reshape(org_codons,1,length(org_codons)*3);
    phase_seq = nt_seq(1+phase:end-3+phase);
    codons=reshape(phase_seq,3,length(phase_seq)/3);
    stops = find(all(codons == repmat(mynt2int('TGA')',1,length(codons)))|...
                 all(codons == repmat(mynt2int('TAG')',1,length(codons)))|...
                 all(codons == repmat(mynt2int('TAA')',1,length(codons))));
end
   
if length(org_codons) < len
    'warning: sequence is too short'
end

nt_seq = reshape(org_codons,1,length(org_codons)*3);

ntintseq = nt_seq(1:len*3);

